=== debian/changelog ===
freespace2 (25.0.0~rc11+repack-1) unstable; urgency=medium

  * New upstream release.
    + Fix FTBFS with CMake 4.2 (Closes: #1125529)
  * Update d/copyright
  * Revert back to embedded imgui
  * Remove freespace2-data-{gog,volition} & video package skeletons.
    The supported way is to use game-data-packager.

 -- Sébastien Noel <sebastien@twolife.be>  Thu, 29 Jan 2026 09:29:17 +0100

freespace2 (24.2.0+repack-3) unstable; urgency=medium

  * Yet another rebuild for ffmpeg 8; last i386 build was against ffmpeg 7

 -- Sébastien Noel <sebastien@twolife.be>  Tue, 16 Dec 2025 08:36:09 +0100

freespace2 (24.2.0+repack-2) unstable; urgency=medium

  * Fix build against ffmpeg 8 (Closes: #1115029)

 -- Sébastien Noel <sebastien@twolife.be>  Sat, 13 Dec 2025 21:21:54 +0100
