=== debian/packages/freespace2-mod-mediavps/debian/watch ===
# uscan(1)

# this file is for update checking only.
# use "debian/rules get-orig-source" to get upstream archives.

version=3

#opts=\
#uversionmangle=s/(\d)(\d)(\d+)/$1.$2.$3/,\
#dversionmangle=s/\+upd\d+//,\
# https://www.hard-light.net/forums/index.php?topic=99050.0 \
# */MediaVPs_(\d+)\.zip
