=== debian/changelog ===
freespace2 (25.0.0+repack-1) unstable; urgency=medium

  * New upstream release.

 -- Sébastien Noel <sebastien@twolife.be>  Sat, 14 Feb 2026 13:17:42 +0100
