=== debian/control ===
Source: freespace2
Section: non-free/games
Standards-Version: 4.7.3
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders: Dmitry Smirnov <onlyjob@debian.org>,
           Sébastien Noel <sebastien@twolife.be>
Build-Depends: debhelper-compat (= 13),
               antlr4,
               cmake,
               glslang-tools,
               glslc,
               libantlr4-runtime-dev,
               libavcodec-dev,
               libavformat-dev,
               libavutil-dev,
               libdiscord-rpc-dev,
               libfreetype-dev,
               libgl-dev,
               libglu1-mesa-dev,
               libgtest-dev,
               libhidapi-dev,
               libimgui-dev,
               libjansson-dev,
               libjpeg-dev,
               liblua5.1-0-dev,
               liblz4-dev,
               libopenal-dev,
               libopenxr-dev,
               libpng-dev,
               libsdl2-dev,
               libstb-dev,
               libswresample-dev,
               libswscale-dev,
               libtheora-dev,
               libutfcpp-dev,
               libvorbis-dev,
               libvulkan-dev,
               libxcb-glx0-dev,
               zlib1g-dev
Homepage: http://scp.indiegames.us/
XS-Autobuild: yes
Vcs-Browser: https://salsa.debian.org/games-team/freespace2
Vcs-Git: https://salsa.debian.org/games-team/freespace2.git

Package: freespace2
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Recommends: freespace2-data | game-data-packager, freespace2-launcher
Suggests: dpkg-dev, check-dfsg-status, freespace2-mod-mediavps, joystick
Description: open implementation of the Freespace 2 game engine
 FreeSpace is a series of space combat simulation games developed
 by Volition, Inc. and published by Interplay Entertainment.
 The games take place in the 24th century. Mankind, referred to as
 Terrans, has developed means for space traveling, further fueled
 by the discovery of subspace which makes interstellar travel not
 only possible but also fast and easy. As a result the Terrans have
 expanded their territory, eventually encountering another bipedal,
 sentient species; the Vasudans. However, due to cultural differences
 and difficulties in communicating with each other, the Galactic Terran
 Alliance (GTA) and the Parliamentary Vasudan Empire (PVE) end up fighting
 a war that lasts for 14 years.
 .
 Original game files from CD are needed to play this game.
