=== debian/watch ===
# https://salsa.debian.org/snippets/95
# https://wiki.debian.org/debian/watch
# uscan(1) configuration file.
version=4

opts="\
pgpmode=none,\
compression=xz,\
repack,repacksuffix=+repack,\
dversionmangle=s{[+~](repack|dfsg)\d*}{},\
uversionmangle=s{_RC}{~rc};s{-RC}{~rc};s{_}{.}g,\
filenamemangle=s{release_([\d\._]+)}{@PACKAGE@-$1.tar.gz},\
searchmode=plain,\
" https://api.github.com/repos/scp-fs2open/fs2open.github.com/releases?per_page=99 \
  https://api.github.com/repos/[^/]+/[^/]+/tarball/v?release_([\d\-._A-Z]+) \
  debian uupdate

# librocket
opts="component=librocket, \
      mode=git, \
      pgpmode=none, \
      pretty=%cd.%h, \
      repack, \
      compression=xz, \
      dversionmangle=auto" \
https://github.com/scp-fs2open/libRocket.git HEAD \
ignore

# cmake-modules
opts="component=cmake-modules, \
      mode=git, \
      pgpmode=none, \
      pretty=%cd.%h, \
      repack, \
      compression=xz, \
      dversionmangle=auto" \
https://github.com/rpavlik/cmake-modules.git HEAD \
ignore
